/* (C) 2022 YiRing, Inc. */
package com.yiring.app.service.appletUser.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.yiring.app.domain.appletUser.AppletUser;
import com.yiring.app.domain.appletUser.AppletUserRepository;
import com.yiring.app.feign.WxClient;
import com.yiring.app.service.appletUser.AppletUserService;
import com.yiring.common.core.Result;
import java.util.Optional;
import javax.annotation.Resource;

/**
 * @author Administrator
 * @version 1.0
 * @description: TODO
 * @date 2022/4/24 9:25
 */
public class AppletUserServiceImpl implements AppletUserService {

    @Resource
    AppletUserRepository appletUserRepository;

    @Resource
    WxClient wxClient;

    @Override
    public Result<String> selectMobile(String appid, String secret, String js_code, String grant_type) {
        JSONObject jsonObject = wxClient.getOpenid(appid, secret, js_code, grant_type);
        Object openid = jsonObject.get("openid");
        if (StrUtil.isNotBlank(openid.toString())) {
            Optional<AppletUser> optional = appletUserRepository.findById(openid.toString());
            //如果该微信为第一次登录小程序
            if (optional.isEmpty()) {
                return Result.ok("绑定手机号码");
            }
            AppletUser appletUser = optional.get();
            return Result.ok(appletUser.getMobile());
        }
        return null;
    }
}
